      SUBROUTINE LSQINIT
C     .... Initialize DOLSQ enviroment
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      M_PMAX=100
      M_OMAX=2500
C     .... All Obs flag reset ....
      DO N=1,M_OMAX
         I_GOOD(N)=0
      END DO
C     .... All parameter flag set
      DO M=1,M_PMAX
         I_FLAG(M)=1
      END DO
      I_DBK=0
C
      RETURN
      END
C
      SUBROUTINE LSQDEBUG
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      I_DBK=1
      RETURN
      END
C
C
      SUBROUTINE LSQGETMAX(MAXOBS,MAXPARA)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      MAXOBS=M_OMAX
      MAXPARA=M_PMAX
      RETURN
      END
C
      SUBROUTINE LSQSETSIZE(NOBS,NPARA)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      N_DATA=NOBS
      N_PARA=NPARA
C     .... Flag Initialize
C     DO N=1,NOBS
C        I_GOOD(N)=1
C     END DO
C     DO M=1,NPARA
C        I_FLAG(M)=1
C     END DO
      RETURN
      END
C
C
      SUBROUTINE LSQSETFLAG(A1,NM,A2)
      IMPLICIT REAL*8(D)
      CHARACTER*(*) A1,A2
      INCLUDE "LSQ_F_INCLUDE.TXT"
      IF(A1(1:3).EQ.'PAR') THEN   !  parameter flag
         IF(A2(1:3).EQ.'YES') THEN
            I_FLAG(NM)=1
         ELSE IF(A2(1:2).EQ.'NO') THEN
            I_FLAG(NM)=0
         ENDIF
      ELSE IF(A1(1:3).EQ.'OBS') THEN   ! OBS FLAG
         IF(A2(1:4).EQ.'GOOD') THEN
            I_GOOD(NM)=1
         ELSE IF(A2(1:3).EQ.'BAD') THEN
            I_GOOD(NM)=0
         ENDIF
      ENDIF
      RETURN
      END
C
C
      SUBROUTINE LSQGETFLAG(A1,NM,IFLAG)
      IMPLICIT REAL*8(D)
      CHARACTER*(*) A1
      INCLUDE "LSQ_F_INCLUDE.TXT"
      IF(A1(1:3).EQ.'PAR') THEN   !  parameter flag
         IFLAG=I_FLAG(NM)
      ELSE IF(A1(1:3).EQ.'OBS') THEN   ! OBS FLAG
         IFLAG=I_GOOD(NM)
      ENDIF
      RETURN
      END
C
      SUBROUTINE LSQPFLAG(M)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      I_FLAG(M)=0
      RETURN
      END
C
C
C
      SUBROUTINE LSQOFLAG(N)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      I_GOOD(N)=0
      RETURN
      END
C
C
      SUBROUTINE LSQPFLAGR(M)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      I_FLAG(M)=1
      RETURN
      END
C
C
C
      SUBROUTINE LSQOFLAGR(N)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      I_GOOD(N)=1
      RETURN
      END
C
C
C
C
      SUBROUTINE LSQGETPFLAG(M,IFLAG)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      IFLAG=I_FLAG(M)
      RETURN
      END
C
C
C
      SUBROUTINE LSQGETOFLAG(N,IGOOD)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      IGOOD=I_GOOD(N)
      RETURN
      END
C
C
C
C
      SUBROUTINE LSQSETJACOB(A,N,M,IERR)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      IERR=0
      IF(N.GT.M_OMAX) THEN
         IERR=-1
         WRITE(6,*) ' Data position (Obs direction) exceeds limit (',
     .   M_OMAX,')'
         RETURN
      ENDIF
      IF(M.GT.M_PMAX) THEN
         IERR=-2
         WRITE(6,*) ' Parameter #  exceeds limit (',
     .   M_PMAX,')'
         RETURN
      ENDIF
      D_A(N,M)=A
      RETURN
      END
C
C
C
C
      SUBROUTINE LSQSETDJACOB(DA,N,M,IERR)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      IERR=0
      IF(N.GT.M_OMAX) THEN
         IERR=-1
         WRITE(6,*) ' Data position (Obs direction) exceeds limit (',
     .   M_OMAX,')'
         RETURN
      ENDIF
      IF(M.GT.M_PMAX) THEN
         IERR=-2
         WRITE(6,*) ' Parameter #  exceeds limit (',
     .   M_PMAX,')'
         RETURN
      ENDIF
      D_A(N,M)=DA
      RETURN
      END
C
C
C
C
      SUBROUTINE LSQSETOBS(Y,YERR,N)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      IERR=0
      IF(N.GT.M_OMAX) THEN
         IERR=-1
         WRITE(6,*) ' Data position (Obs direction) exceeds limit (',
     .   M_OMAX,')'
         RETURN
      ENDIF
      R_Y(N)=Y
      R_YERR(N)=YERR
      I_GOOD(N)=1
      RETURN
      END
C
C
      SUBROUTINE LSQGETKAI(X,XERR,M)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      IERR=0
      IF(M.GT.N_PARA) THEN
         IERR=-1
         RETURN
      ENDIF
      X=X_ADJ(M)
      XERR=DSQRT(R_CHI2*DABS(D_COVX(M,M)))
C      XERR=DSQRT(R_SIGMA*R_SIGMA*DABS(D_COVX(M,M))) ! same as 1 line above
      RETURN
      END
C
C
C
C
      SUBROUTINE LSQGETCOR(C,M1,M2)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      IERR=0
      IF(M1.GT.N_PARA.OR.M2.GT.N_PARA) THEN
         IERR=-1
         RETURN
      ENDIF
      C=D_CORX(M1,M2)
      RETURN
      END
C
C
C
C
C
      SUBROUTINE LSQGETCOV(V,M1,M2)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      IERR=0
      IF(M1.GT.N_PARA.OR.M2.GT.N_PARA) THEN
         IERR=-1
         RETURN
      ENDIF
      V=D_COVX(M1,M2)
      RETURN
      END
C
C
C
      SUBROUTINE LSQGETSTD(RSUM2,RSIGMA,RCHI2,NFREE,NDATA,MPARA)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      RSUM2=R_SUM2
      RSIGMA=R_SIGMA
      RCHI2=R_CHI2
      NFREE=N_FREE
      NDATA=N_OBS
      MPARA=M_PARA
      RETURN
      END
C
C
      SUBROUTINE LSQGETOMC(OMC,N)
      IMPLICIT REAL*8(D)
      INCLUDE "LSQ_F_INCLUDE.TXT"
      OMC=R_OMC(N)
      RETURN
      END
C
C
C
      SUBROUTINE DOLSQ(IERR)
********************************************************************
*    LEAST SQARES METHOD BY S.V.D                                  *
*             by T.Kon for general purpose                         *
*          91-05-10                                                *
*                                                                  *
*      Weighting with unit (i.e.  W=1/ERR**2) is adopted here      *
*      so as to handle different unit obs data in the fitting      *
*                                                                  *
*     Maximum # of parameters  100                                 *
*     Maximum # of data       1500                                 *
*                                                                  *
*                                                                  *
*     I/O   via EMA array                                          *
*                                                                  *
*     IERR= 0   :  normal return                                   *
*     IERR=-1   :  Error occured                                   *
********************************************************************
C
      IMPLICIT REAL*8(D)
C
      DIMENSION
     . IAJST(100)    ! Adjust parameter indicator from origin to reduced size
C
      INCLUDE "LSQ_F_INCLUDE.TXT"
CC    COMMON /LSQ/
C       .......  Data Prepared by main routine and return to main
CC   . R_Y(2500)       ! Observed data (O-C in case of non linear lsq)
CC   .,R_YERR(2500)    ! 1 sigma error of observed data
CC   .,I_GOOD(2500)    ! Flag indicate good obs data   1:OK  0: NO
CC   .,D_A(2500,100)   ! Jacobian (oroginal) not affected
CC   .,R_OMC(2500)     ! O-C after fitting            (return)
CC   .,X_ADJ(100)      ! Adjustment value calculated
CC                     !    must be added to paramters in main
CC   .,I_FLAG(100)     ! Adjusting parameter indicator
CC                     !   1: Adjust  0 : no Adjust  will be affected
CC                     !    -1 means rank ochi occurred parameter
CC   .,D_CORX(100,100) ! Obtained correlation matrix (return)
CC   .,D_COVX(100,100) ! Obtained covariance matrix  (return)
CC   .,R_SUM2          ! Sum of residual square   (return)
CC   .,R_SIGMA         ! Residual 1 sigma         (return)
CC   .,R_CHI2          ! Reduced chi squer        (return)
CC   .,N_FREE          ! Degree of freedum        (return)
CC   .,M_PMAX          ! Available max # of parameters =100
CC   .,M_OMAX          !    "               data =2500
CC   .,N_DATA          ! # of data valid   <= M_OMAX
CC   .,N_PARA          ! # of parameters in X_PRM etc.
CC   .,M_PARA          ! Actual # of parameters fitted    (Return)
CC   .,I_DBK           ! Debug control   1 : DEBUG ON  0 : DEBUG OFF
C
      COMMON /LSQWRK/
C       .......  Arrays used in this routine only
     . D_WA(2500,100)      !  Jacobian weighted and reordered wrt parametrs
     .,DU(2500,100)        !  U of SVD bunkai
     .,DV(2500,100)        !  V of SVD bunkai
     .,DSIGMA(100)         !  Contain singular value
     .,DWORK(100)          !  Work array
     .,D_Y(2500)           !  Weighted Observed data
     .,DFACT(100)          !  Scaling factor
C
      DATA EPSM/2.0E-16/      ! Machine epsiron
C
C     IDBK=1       ! DEBUG ON
C     IDBK=0       ! DEBUG OFF
      IDBK=I_DBK
      LUO=1        ! DEBUG OUT LU
C
C     M_PMAX=100      ! PARAMETER MAX
C     M_OMAX=2500     ! MATRIX ROW MAX (AVAILABLE MAX OBS NUMBER)
C
      MAXX=M_PMAX
      MAXY=M_OMAX
      NOBS=N_DATA
C
C     Now D_A(MAXY,MAXX) is a Jacobian Array
C         D_Y(MAXY)     is a observed data
C
C
C-----Adjust and skip of parameter order....
C     .... Make conversion table that convert parameter position in
C          this routine to actual parameter position
C
      DO M=1,MAXX
         IAJST(M)=0
      ENDDO
C
      K=0
      DO M=1,N_PARA      ! N_PARA .LE. MAXX
         IF(I_FLAG(M).NE.0) THEN
            K=K+1
            IAJST(K)=M
         ENDIF
      END DO
C
      M_PARA=K       ! Actual number of parameters adjusted
C
      IF(IDBK.EQ.1) THEN
         WRITE(6,*) 'Flag monitor'
         WRITE(6,*) 'Raw Flag ',(I_FLAG(M),M=1,N_PARA)
         WRITE(6,*) 'Adjust   ',(IAJST(M),M=1,M_PARA)
      ENDIF
C
C     ...... Jacobian copy to D_WA() with weighting and rearrange
      DO N=1,NOBS
C
C         ..... D_WA clear wrt parameters
         DO M=1,MAXX
            D_WA(N,M)=0.0
         END DO
         D_Y(N)=0.0
C
C       ..... WEIGHTING  Jacobian and Obeserved data...
C         ....  D_Y vector weighting ...
C         ... We adopted weighting with unit so as to allow different
C             observed value (in unit) in obs data
C         ..... Jacovian reorder and weighting (if so)
C        IF(I_GOOD(N).GE.0) THEN        ! good obs only
         IF(I_GOOD(N).GT.0) THEN        ! debug on 92/12/8
C                                       ! pointed out by Mr.OHTSUBO
            D_Y(N)=R_Y(N)/R_YERR(N)           !  in case of with unit
C
CC          IF(IDBK.EQ.1) THEN
CC             WRITE(LUO,*)' Obs#=',N,'  Y=',R_Y(N),'+/-',R_YERR(N),
CC   .                   '  WY=',D_Y(N)
CC          ENDIF
C
            DO M=1,M_PARA
               MPOS=IAJST(M)        ! Actual parameter position in Jacobian
C              D_WA(N,M)=D_A(N,MPOS)*YESIGM/R_YERR(N)
               D_WA(N,M)=D_A(N,MPOS)/R_YERR(N)
            END DO
         ENDIF
CC       IF(IDBK.EQ.1) THEN
CC          WRITE(LUO,*) 'Jacobian(raw)',(D_A(N,M),M=1,M_PARA)
CC          WRITE(LUO,*) 'Jacobian(wgt)',(D_WA(N,M),M=1,M_PARA)
CC       ENDIF
C
      END DO
C
C     Scaling of Jacobian to improve condition number
C     ..... Scaling factor is taken here as a max of ABS(D_WA) in each
C              parameters.
      DO M=1,M_PARA
C        CALL DWMAB(NP,D_WA(1,M),1,NOBS)    ! VIS CALL
C        DAMX=DABS(D_WA(NP,M))
C        ... non VIS version
         DAMX=DABS(D_WA(1,M))
         DO N=1,NOBS
            IF(DABS(D_WA(N,M)).GT.DAMX) DAMX=DABS(D_WA(N,M))
         END DO
C
         IF(DAMX.LT.1.0D-20) THEN
            DFACT(M)=1.0
         ELSE
            DFACT(M)=1.0/DAMX
         ENDIF
      END DO
      IF(IDBK.EQ.1) THEN
         WRITE(6,'(" SCALING FACTOR (DFACT) ")')
         WRITE(6,*) (DFACT(I),I=1,M_PARA)
      ENDIF
C     ..... do scaling of Jacobian ......
      DO M=1,M_PARA
         DO N=1,NOBS
            D_WA(N,M)=D_WA(N,M)*DFACT(M)
         END DO
      END DO
C
C ----------- Singular Value Decomposition (SVD) ------
C
      MPARA=M_PARA
      CALL DWSVD_2(MAXY,NOBS,MAXX,MPARA,D_WA,DSIGMA,
     .            .TRUE.,DU,.TRUE.,DV,KERR,DWORK)
      IF(IDBK.EQ.1) THEN
         WRITE(LUO,*) 'Singular Value (DSIGMA)'
         WRITE(LUO,*) (DSIGMA(I),I=1,M_PARA)
      ENDIF
      IERR=0
      IF(KERR.NE.0) THEN
         WRITE(6,'(" DWSVD_2 ERROR",I10)') KERR
         IERR=-1
         RETURN
      ENDIF
C     ......... Maximum singular value finding ............
      DSIG1=0.0
      DO M=1,M_PARA
         IF(DSIGMA(M).GT.DSIG1) DSIG1=DSIGMA(M)
      END DO
C
C     ........ Absolute error limit definition ............
C
      RELERR=FLOAT(M_PARA)*EPSM
      DTAU=RELERR*DSIG1
C
C     ........ Finding null coefficent
C
      IRANK=M_PARA
      DSMAX=0.0
      DSMIN=1.0D30
      DO M=1,M_PARA
         IF(DSIGMA(M).GT.DTAU) THEN
            IF(DSIGMA(M).GT.DSMAX) DSMAX=DSIGMA(M)
            IF(DSIGMA(M).LT.DSMIN) DSMIN=DSIGMA(M)
         ELSE   !  rank defficency occurred
            MPOS=IAJST(M)    ! MPOS is actual parameter position in main
            I_FLAG(MPOS)=-1    ! mean where rank deficiency occurred
            WRITE(6,'(" Singular Value for Parameter # ",I4,
     .                   " is .LE. DTAU(",E12.3,")")') MPOS,DTAU
            WRITE(6,*) ' This parameter (',MPOS,') not adjusted here!'
C
            IRANK=IRANK-1
            WRITE(6,'(" NULL COEFFICIENTS")')
            WRITE(6,*) (DV(K,M),K=1,M_PARA)
         ENDIF
      END DO
C
C     ..... CHECK CONDITION NUMBER .....
      COND=DSMAX/DSMIN
C
      IF(IDBK.EQ.1) THEN
         WRITE(6,'(" No.of Parameters =",I3,"    Rank =",I3)')
     .   M_PARA,IRANK
         IF(M_PARA.EQ.IRANK)
     .   WRITE(6,'(" Coefficient are unique ")')
         WRITE(6,*) 'SVmax=',DSMAX,'   SVmin=',DSMIN
         WRITE(6,'(" CONDITION NUMBER = _")')
         WRITE(6,*) COND
      ENDIF
C
      IF(COND.GT.1.0/EPSM) THEN
         WRITE(6,'("!!!!!!!! WARNING !!!!!!!!!!!!")')
         WRITE(6,'("!!  BAD CONDITION NUMNER  !!!")')
         WRITE(6,'("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!")')
      ENDIF
C
C     ........ ADJUSTING VECTOR CALC .....
C
      DO M=1,MAXX
         X_ADJ(M)=0.0
      END DO
C
      DO M=1,M_PARA
         MPOS=IAJST(M)
         IF(I_FLAG(MPOS).GT.0) THEN    ! Adjusting vector calc
            DSUM=0.0
            DO N=1,NOBS
               DSUM=DSUM+DU(N,M)*D_Y(N)
            END DO
            DSUM=DSUM/DSIGMA(M)
            DO I=1,M_PARA
               X_ADJ(I)=X_ADJ(I)+DSUM*DV(I,M)   ! OK   Check Zumi
            END DO
         ENDIF
      END DO
      DO J=1,M_PARA
         X_ADJ(J)=X_ADJ(J)*DFACT(J)
      END DO
C
      IF(IDBK.EQ.1) THEN
         WRITE(LUO,'(" ADJUSTING VECTOR X_ADJ(I)")')
         WRITE(LUO,*) (X_ADJ(I),I=1,M_PARA)
      ENDIF
C
C
C     ..... COVARIANCE MATRIX CALC    D_COVX(100,100).........
C
      DO N=1,M_PARA
         DO M=1,M_PARA
            DSUM=0.0
            DO K=1,M_PARA
               MPOS=IAJST(K)
               IF(I_FLAG(MPOS).GT.0) THEN
                  DSUM=DSUM+DV(N,K)*DV(M,K)/(DSIGMA(K)*DSIGMA(K))   ! original
C                 DSUM=DSUM+DV(K,N)*DV(K,M)/(DSIGMA(K)*DSIGMA(K))
               ENDIF
            END DO
            D_COVX(N,M)=DSUM
         END DO
      END DO
C
C    ..... Do scaling of covariance matrix using DFACT ..
C
      DO N=1,M_PARA
         DO  M=1,M_PARA
            D_COVX(N,M)=D_COVX(N,M)*DFACT(N)*DFACT(M)
         END DO
      END DO
C
C
C
      IF(N_PARA.NE.M_PARA) THEN
C
C     ...... Re arrange acording to actual parameter position
C        .... Rearange X_ADJ
C          here R_OMC  used for temporal save
C
         DO M=1,N_PARA             !  N_PARA is initial # of parameter
            R_OMC(M)=X_ADJ(M)
            X_ADJ(M)=0.0
         END DO
C
         DO M=1,M_PARA             !  M_PARA is # of parameters adjusted
            MPOS=IAJST(M)
            X_ADJ(MPOS)=R_OMC(M)
         END DO
C
C
C
C        ... Rearange D_COVX
C        ..... D_CORX is used as work array here
         DO M1=1,N_PARA
            DO M2=1,N_PARA
               D_CORX(M1,M2)=0.0
            END DO
         END DO
         DO M1=1,M_PARA
            M1POS=IAJST(M1)
            IF(I_FLAG(M1POS).GT.0) THEN
               DO M2=1,M_PARA
                  M2POS=IAJST(M2)
                  IF(I_FLAG(M2POS).GT.0) THEN
                     D_CORX(M1POS,M2POS)=D_COVX(M1,M2)
                  ENDIF
               END DO
            ENDIF
         END DO
C        ... copy back
         DO M1=1,N_PARA
            DO M2=1,N_PARA
               D_COVX(M1,M2)=D_CORX(M1,M2)
            END DO
         END DO
C
C      ... Now position of D_COVX correspond actual parameter position
C
      ENDIF    ! End of rearanging
C
C
      IF(IDBK.EQ.1) THEN
         WRITE(LUO,'(" COVARIANCE MATRIX")')
         DO M=1,N_PARA
            WRITE(LUO,'(I3,1X,19F10.5)')
     .      M,(D_COVX(M,I),I=1,N_PARA)
         END DO
      ENDIF
C
C     ...... CORRELATION MATRIX CALC  D_CORX(100,100).........
C
      DO M1=1,N_PARA
         DO M2=1,N_PARA
            D_CORX(M1,M2)=0.0
            IF(I_FLAG(M1).GT.0.AND.I_FLAG(M2).GT.0) THEN  ! cal for actual
                                                          ! parameter only
               DBUNBO=DSQRT(DABS(D_COVX(M1,M1)*D_COVX(M2,M2)))
               D_CORX(M1,M2)=D_COVX(M1,M2)/DBUNBO
            ENDIF
         END DO
      END DO
C
      IF(IDBK.EQ.1) THEN
         WRITE(LUO,'("  CORRELATION MATRIX (%)")')
         DO M=1,N_PARA
            WRITE(LUO,'(I3,1X,40I4)')
     .      M,(D_CORX(M,I)*100.0,I=1,N_PARA)
         END DO
      ENDIF
C
C
C
C     ........   O - C , nomalized sum square of residuals (R_SUM2)
C                Scaled chi square (R_CHI2),
C                Scaling const (sigma star = R_SIGMA)
C                etc calc.
C
      NSUM=0
      R_SUM2=0.0
      DO N=1,NOBS
         RSUM=0.0
         R_OMC(N)=0.0
         IF(I_GOOD(N).GT.0) THEN  !   This is OK obs
            NSUM=NSUM+1
            DO M=1,N_PARA
               RSUM=D_A(N,M)*X_ADJ(M)+RSUM
            END DO
            OMINUSC=R_Y(N)-RSUM
            R_OMC(N)=OMINUSC
            R_SUM2=R_SUM2+OMINUSC*OMINUSC/(R_YERR(N)*R_YERR(N))
         ENDIF
      END DO
      N_OBS=NSUM            ! # of good obs
      N_FREE=NSUM-M_PARA    !   This is degree of freedum
C
C     in case of weight having unit  Reduced Chi^2 = Scaleing sigma^2
      IF(N_FREE.GT.0) THEN
         R_CHI2=R_SUM2/FLOAT(N_FREE)
         R_SIGMA=SQRT(R_CHI2)
      ELSE
         R_SIGMA=0.0
         R_CHI2=0.0
      ENDIF
C
      RETURN
      END
C
C
C
C$CDS OFF
C
      SUBROUTINE DWSVD_2(NM,M,NN,N,A,W,MATU,U,MATV,V,IERR,RV1)
      IMPLICIT REAL*8 (A-H,O-Z)
C     EMA A,W,U,V,RV1
      DIMENSION A(NM,NN),W(NN),U(NM,NN),V(NM,NN),RV1(NN)
      LOGICAL MATU,MATV
C
C   EMA version
C     This subroutine is a copy of SVD, in the
C     "Keisanki no tameno suuchi keisanhou"
C
C     This subroutine determines the singular value decomposition
C        T
C     A=USV of a real M by N rectangular matrix.  Householder
C     bidiagonalization and a variant of the QR algorithm are used.
C
C     On input.
C
C       NM must be set to the row dimension of two-dimensional
C          array parameters as declared in the calling program
C          dimension statement. Note that NM must be at least
C          as large as the maximum of M and N.
C
C       M is the number of rows of A (and U).
C
C       NN is the number of columns of A (and U) and the order of V.
C
C       N is the real number of columns of A (and U) and the order of V.
C
C       A contains the rectangular input matrix to be decomposed.
C
C       MATU should be set to .TRUE. if the U matrix in the
C          decomposition is desired, and to .FALSE. otherwise.
C
C       MATV should be set to .TRUE. if the V matrix in the
C          decomposition is desired, and to .FALSE. otherwise.
C
C     On output.
C       A is unaltered (unless overwritten by U or V).
C
C       W contains the N (non-negative) singular values of A (the
C          diagonal elements of S). They are unordered. If an
C          error exit is made, the singular values should be correct
C          for indices IERR+1,IERR+2,...,N.
C
C       U contains the matrix U (orthogonal column vectors) of the
C          decomposition if MATU has been set to .TRUE. otherwise
C          U is used as a temporary array. U may coincide with A.
C          If an error exit is made, the columns of U corresponding
C          to indices of correct singular valuesw should be correct.
C
C       V contains the matrix V (orthogonal) of the decomposition if
C          MATV has been set to .TRUE. otherwise V is not referenced.
C          V may also coincide with A if U is not needed. If an error
C          exit is made, the columns of V corresponding to indices of
C          correct singular values should be correct.
C
C       IERR is set to
C          zero     for normal return,
C          K        if the K-th singular value has not been determined
C                   after 30 iterations.
C
C       RV1 is a temporary storage array.
C
      IERR=0
C
      DO 100 I=1,M
         DO 100 J=1,N
            U(I,J)=A(I,J)
  100 CONTINUE
C     ...... HOUSEHOLDER REDUCTION TO BIDIAGONAL FORM ......
      G=0.0
      SCALE=0.0
      ANORM=0.0
C
      DO 300 I=1,N
         L=I+1
         RV1(I)=SCALE*G
         G=0.0
         S=0.0
         SCALE=0.0
         IF(I.GT.M) GO TO 210
C
         DO 120 K=I,M
  120    SCALE=SCALE+DABS(U(K,I))
C
         IF(SCALE.EQ.0.0) GO TO 210
C
         DO 130 K=I,M
            U(K,I)=U(K,I)/SCALE
            S=S+U(K,I)**2
  130    CONTINUE
C
         F=U(I,I)
         G=-DSIGN(DSQRT(S),F)
         H=F*G-S
         U(I,I)=F-G
         IF(I.EQ.N) GO TO 190
C
         DO 150 J=L,N
            S=0.0
C
            DO 140 K=I,M
  140       S=S+U(K,I)*U(K,J)
C
            F=S/H
C
            DO 150 K=I,M
               U(K,J)=U(K,J)+F*U(K,I)
  150    CONTINUE
C
  190    DO 200 K=I,M
  200    U(K,I)=SCALE*U(K,I)
C
  210    W(I)=SCALE*G
         G=0.0
         S=0.0
         SCALE=0.0
         IF(I.GT.M.OR.I.EQ.N) GO TO 290
C
         DO 220 K=L,N
  220    SCALE=SCALE+DABS(U(I,K))
C
         IF(SCALE.EQ.0.0) GO TO 290
C
         DO 230 K=L,N
            U(I,K)=U(I,K)/SCALE
            S=S+U(I,K)**2
  230    CONTINUE
C
         F=U(I,L)
         G=-DSIGN(DSQRT(S),F)
         H=F*G-S
         U(I,L)=F-G
C
         DO 240 K=L,N
  240    RV1(K)=U(I,K)/H
C
         IF(I.EQ.M) GO TO 270
C
         DO 260 J=L,M
            S=0.0
C
            DO 250 K=L,N
  250       S=S+U(J,K)*U(I,K)
C
            DO 260 K=L,N
               U(J,K)=U(J,K)+S*RV1(K)
  260    CONTINUE
C
  270    DO 280 K=L,N
  280    U(I,K)=SCALE*U(I,K)
C
  290    ANORM=DMAX1(ANORM,DABS(W(I))+DABS(RV1(I)))
  300 CONTINUE
C     ..... ACCUMULATION OF RIGHT-HAND TRANSFORMATIONS .......
      IF(.NOT.MATV) GO TO 410
C     ..... FOR I=N STEP -1 UNTIL 1 DO -- ..........
      DO 400 II=1,N
         I=N+1-II
         IF(I.EQ.N) GO TO 390
         IF(G.EQ.0.0) GO TO 360
C
         DO 320 J=L,N
C        ......  DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ....
  320    V(J,I)=(U(I,J)/U(I,L))/G
C
         DO 350 J=L,N
            S=0.0
C
            DO 340 K=L,N
  340       S=S+U(I,K)*V(K,J)
C
            DO 350 K=L,N
               V(K,J)=V(K,J)+S*V(K,I)
  350    CONTINUE
C
  360    DO 380 J=L,N
            V(I,J)=0.0
            V(J,I)=0.0
  380    CONTINUE
C
  390    V(I,I)=1.0
         G=RV1(I)
         L=I
  400 CONTINUE
C     ..... ACCUMULATION OF LEFT-HAND TRANSFORMATIONS .....
  410 IF(.NOT.MATU) GO TO 510
C     ..... FOR I=MIN(M,N) STEP -1 UNTIL 1 DO -- .........
      MN=N
      IF(M.LT.N) MN=M
C
      DO 500 II=1,MN
         I=MN+1-II
         L=I+1
         G=W(I)
         IF(I.EQ.N) GO TO 430
C
         DO 420 J=L,N
  420    U(I,J)=0.0
C
  430    IF(G.EQ.0.0) GO TO 475
         IF(I.EQ.MN) GO TO 460
C
         DO 450 J=L,N
            S=0.0
C
            DO 440 K=L,M
  440       S=S+U(K,I)*U(K,J)
C           ...... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW .....
            F=(S/U(I,I))/G
C
            DO 450 K=I,M
               U(K,J)=U(K,J)+F*U(K,I)
  450    CONTINUE
C
  460    DO 470 J=I,M
  470    U(J,I)=U(J,I)/G
C
         GO TO 490
C
  475    DO 480 J=I,M
  480    U(J,I)=0.0
C
  490    U(I,I)=U(I,I)+1.0
  500 CONTINUE
C     ..... DIAGONALIZATION OF THE BIDIAGONAL FORM .........
C     ..... FOR K=N STEP -1 UNTIL 1 DO -- ........
  510 DO 700 KK=1,N
         K1=N-KK
         K=K1+1
         ITS=0
C        ..... TEST FOR SPLITTING.
C               FOR L=K STEP -1 UNTIL 1 DO -- .........
  520    DO 530 LL=1,K
            L1=K-LL
            L=L1+1
            IF(DABS(RV1(L))+ANORM.EQ.ANORM) GO TO 565
C           ... RV1(I) IS ALWAYS ZERO, SO THERE IS NO EXIT
C               THROUGH THE BOTTOM OF THE LOOP ......
            IF(DABS(W(L1))+ANORM.EQ.ANORM) GO TO 540
  530    CONTINUE
C        ..... CANCELLATION OF RV1(L) IF L GREATER THAN 1 ....
  540    C=0.0
         S=1.0
C
         DO 560 I=L,K
            F=S*RV1(I)
            RV1(I)=C*RV1(I)
            IF(DABS(F)+ANORM.EQ.ANORM) GO TO 565
            G=W(I)
            H=DSQRT(F*F+G*G)
            W(I)=H
            C=G/H
            S=-F/H
            IF(.NOT.MATU) GO TO 560
C
            DO 550 J=1,M
               Y=U(J,L1)
               Z=U(J,I)
               U(J,L1)=Y*C+Z*S
               U(J,I)=-Y*S+Z*C
  550       CONTINUE
C
  560    CONTINUE
C        ..... TEST FOR CONVERGENCE ......
  565    Z=W(K)
         IF(L.EQ.K) GO TO 650
C        .... SHIFT FROM BOTTOM 2 BY 2 MINOR ....
         IF(ITS.EQ.30) GO TO 1000
         ITS=ITS+1
         X=W(L)
         Y=W(K1)
         G=RV1(K1)
         H=RV1(K)
         F=((Y-Z)*(Y+Z)+(G-H)*(G+H))/(2.0*H*Y)
         G=DSQRT(F*F+1.0)
         F=((X-Z)*(X+Z)+H*(Y/(F+DSIGN(G,F))-H))/X
C        .... NEXT QR TRANSFORMATION ....
         C=1.0
         S=1.0
C
         DO 600 I1=L,K1
            I=I1+1
            G=RV1(I)
            Y=W(I)
            H=S*G
            G=C*G
            Z=DSQRT(F*F+H*H)
            RV1(I1)=Z
            C=F/Z
            S=H/Z
            F=X*C+G*S
            G=-X*S+G*C
            H=Y*S
            Y=Y*C
            IF(.NOT.MATV) GO TO 575
C
            DO 570 J=1,N
               X=V(J,I1)
               Z=V(J,I)
               V(J,I1)=X*C+Z*S
               V(J,I)=-X*S+Z*C
  570       CONTINUE
C
  575       Z=DSQRT(F*F+H*H)
            W(I1)=Z
C           ... ROTATION CAN BE ARBITRARY IF Z IS ZERO ....
            IF(Z.EQ.0.0) GO TO 580
            C=F/Z
            S=H/Z
  580       F=C*G+S*Y
            X=-S*G+C*Y
            IF(.NOT.MATU) GO TO 600
C
            DO 590 J=1,M
               Y=U(J,I1)
               Z=U(J,I)
               U(J,I1)=Y*C+Z*S
               U(J,I)=-Y*S+Z*C
  590       CONTINUE
C
  600    CONTINUE
C
         RV1(L)=0.0
         RV1(K)=F
         W(K)=X
         GO TO 520
C        .... CONVERGENCE ......
  650    IF(Z.GE.0.0) GO TO 700
C        ... W(K) IS MADE NON-NEGATIVE ......
         W(K)=-Z
         IF(.NOT.MATV) GO TO 700
C
         DO 690 J=1,N
  690    V(J,K)=-V(J,K)
C
  700 CONTINUE
C
      GO TO 1001
C     ...... SET ERROR -- NO CONVERGENCE TO A
C              SINGULAR VALUE AFTER 30 ITERATIONS ....
 1000 IERR=K
 1001 RETURN
      END
