/*
     Test main program for LSQ check 
     
     2005-06-17
     
     by T.Kondo
*/


#include "liblsq.h"

/* test main */
int main(int argc, char *argv[])
{
    double xdat[]={1.0,2.0,3.0,4.0,5.0};
    double ydat[]={3.2,4.2,6.2,5.2,8.2};
    double x,y,yerr,anm;
    double x1,x2,xerr1,xerr2;
    double sum2,sigma,chi2,v1,v2;
    int nfree,ndata,mpara;
    int n,nobs, pmax,omax,m;
    lsq_type_t lsq;

    omax=100; pmax=10;

    lsqinit(&lsq,omax,pmax);

    nobs=5;
    yerr=0.1;

    lsqdebug(&lsq);
    for(n=1; n<=nobs; n++){ /* */
        x=xdat[n-1];
        y=ydat[n-1];
        lsqsetobs(&lsq,y,yerr,n);
        for(m=1; m<=2; m++){
            if(m==1){
                anm=x;
            } else {
                anm=1.0;
            }
            lsqsetjacob(&lsq,anm,n,m);
        }
    }
    lsqsetsize(&lsq,5,2);
    dolsq(&lsq);
    lsqgetkai(&lsq,&x1,&xerr1,1);
    lsqgetkai(&lsq,&x2,&xerr2,2);
    printf("Adjusted parameter a = %f +/- %f\n",x1,xerr1);
    printf("Adjusted parameter b = %f +/- %f\n",x2,xerr2);
    lsqgetstd(&lsq,&sum2,&sigma,&chi2,&nfree,&ndata,&mpara);
    lsqgetcov(&lsq,&v1,1,1);
    lsqgetcov(&lsq,&v2,2,2);
    printf("v1,v2 %f %f\n",v1,v2);
    v1*=sigma*sigma;
    v2*=sigma*sigma;
    printf("v1,v2 %f %f\n",v1,v2);
    for(n=1; n<=nobs; n++){
        lsqgetobs(&lsq,&y,&yerr,n);
        printf("%d %f %f\n",n,y,yerr);
    }
    lsqfinish(&lsq);
}

       
